﻿package 
{
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.util.Colour;
	import com.divillysausages.sprint.gui.GUI;
	import com.divillysausages.sprint.logic.Logic;
	import com.divillysausages.sprint.states.Game;
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	 * The Main class, which controls the game
	 * @author Damian
	 */
	public class Main extends Sprite 
	{
		
		/*******************************************************************************************/
		
		/**
		 * The main game bg colour
		 */
		public static const BG_COLOUR:Colour = Colour.fromHexi( 0xff008000 );
		
		/*******************************************************************************************/
		
		private var m_game:Game		= null;	// the game state manager for the game
		private var m_logic:Logic	= null;	// the game logic object
		private var m_gui:GUI		= null;	// the gui object
		
		/*******************************************************************************************/
		
		/**
		 * The GUI for the game
		 */
		public function get gui():GUI { return this.m_gui; }
		public function set gui( g:GUI ):void
		{
			this.m_gui = g;
		}
		
		/**
		 * The main game {@link Logic} object
		 */
		public function get logic():Logic { return this.m_logic; }
		public function set logic( l:Logic ):void
		{
			this.m_logic = l;
		}
		
		/*******************************************************************************************/
		
		/**
		 * Creates the Main class. If the stage is available, we call _init()
		 * otherwise we wait until we're added
		 */
		public function Main():void 
		{
			if ( this.stage ) this._init();
			else this.addEventListener( Event.ADDED_TO_STAGE, this._init );
		}
		
		/*******************************************************************************************/
		
		// called when the stage is available; inits the game
		private function _init( e:Event = null ):void 
		{
			// remove our stage listener
			this.removeEventListener( Event.ADDED_TO_STAGE, this._init );
			
			// start the engine
			DS.start( this, 60 );
			DS.bgColour 		= Colour.fromHexi( 0xff007100 );
			DS.pauseDisabled 	= true; // disable pause (we only allow it in the play state)
			
			// create our game class
			this.m_game = new Game( this );
			
			// start up
			this.m_game.changeState( Game.STATE_INIT );
		}
		
	}
	
}