package com.divillysausages.sprint.anim 
{
	/**
	 * The AnimFrameInfo object contains all the information we need on a particular frames for a MovieClip
	 * @author Damian Connolly
	 */
	public class AnimFrameInfo
	{
		
		/*************************************************************************************************************/
		
		/**
		 * The name of the animation
		 */
		public var name:String = null;
		
		/**
		 * The starting frame of the animation
		 */
		public var start:int = 0;
		
		/**
		 * The ending frame of the animation
		 */
		public var end:int = 0;
		
		/*************************************************************************************************************/
		
		/**
		 * Creates a new AnimFrameInfo object
		 * @param name	The name of the animation
		 * @param start	The starting frame of the animation
		 * @param end	The ending frame of the animation
		 */
		public function AnimFrameInfo( name:String = null, start:int = 0, end:int = 0 ) 
		{
			this.name 	= name;
			this.start	= start;
			this.end	= end;
		}
		
		/**
		 * Returns the string version of the AnimFrameInfo
		 */
		public function toString():String
		{
			return "[AnimFrameInfo name: " + this.name + ", start: " + this.start + ", end: " + this.end + "]";
		}
		
	}

}