package com.divillysausages.sprint.assets 
{
	import com.divillysausages.ds.asset.EmbeddedAssets;
	
	/**
	 * The resources that we'll use in the game
	 * @author Damian
	 */
	public class Resources extends EmbeddedAssets
	{
		
		/*******************************************************************************************/
		
		/**
		 * The game font
		 */
		public static const GAME_FONT:String = "gameFont";
		
		/**
		 * The ds logo image
		 */
		public static const DS_IMAGE:String = "../../../../../assets/ds_logo.png";
		
		/**
		 * The coin sound
		 */
		public static const COIN_SOUND:String = "../../../../../assets/coin.mp3";
		
		/**
		 * The run sound
		 */
		public static const SFX_RUN:String = "../../../../../assets/run.mp3";
		
		/**
		 * The runner xml
		 */
		public static const RUNNER_XML:String = "../../../../../assets/runner.xml";
		
		/**
		 * The runner image
		 */
		public static const RUNNER_IMAGE:String = "../../../../../assets/runner.png";
		
		/**
		 * The new personal best image
		 */
		public static const NEW_PB_IMAGE:String = "../../../../../assets/newPB.png";
		
		/**
		 * The new world record image
		 */
		public static const NEW_WR_IMAGE:String = "../../../../../assets/newWR.png";
		
		/**
		 * The false start image
		 */
		public static const FALSE_START_IMAGE:String = "../../../../../assets/falseStart.png";
		
		/**
		 * The injury image
		 */
		public static const INJURY_IMAGE:String = "../../../../../assets/injury.png";
		
		/**
		 * The injury icon image
		 */
		public static const INJURY_ICON_IMAGE:String = "../../../../../assets/injury_image.png";
		
		/**
		 * The first image
		 */
		public static const FIRST_IMAGE:String = "../../../../../assets/first.png";
		
		/**
		 * The second image
		 */
		public static const SECOND_IMAGE:String = "../../../../../assets/second.png";
		
		/**
		 * The third image
		 */
		public static const THIRD_IMAGE:String = "../../../../../assets/third.png";
		
		/*******************************************************************************************/
		
		/**
		 * The game font
		 */
		//[Embed(systemFont = "PF Ronda Seven", fontName = "gameFont", mimeType = "application/x-font", fontWeight = "normal", fontStyle = "normal", unicodeRange = "englishRange", advancedAntiAliasing = "true", embedAsCFF = "false")]
		[Embed(source="../../../../../assets/gameFont.ttf", fontName = "gameFont", mimeType = "application/x-font", fontWeight="normal", fontStyle="normal", unicodeRange="englishRange", advancedAntiAliasing="true", embedAsCFF="false")]
		private var m_font:Class;
		
		// the ds logo image
		[Embed(source = "../../../../../assets/ds_logo.png")]
		public var dsImage:Class;
		
		// the coin sound
		[Embed(source = "../../../../../assets/coin.mp3", mimeType = "audio/mpeg")]
		public var coinSound:Class;
		
		// the run sound
		[Embed(source = "../../../../../assets/run.mp3", mimeType = "audio/mpeg")]
		public var runSound:Class;
		
		// the runner spritesheet xml
		[Embed(source="../../../../../assets/runner.xml", mimeType='application/octet-stream')]
		public var runnerXML:Class;
		
		// the runner image
		[Embed(source = "../../../../../assets/runner.png")]
		public var runnerImage:Class;
		
		// the new personal best image
		[Embed(source = "../../../../../assets/newPB.png")]
		public var newPBImage:Class;
		
		// the new world record image
		[Embed(source = "../../../../../assets/newWR.png")]
		public var newWRImage:Class;
		
		// the false start image
		[Embed(source = "../../../../../assets/falseStart.png")]
		public var falseStartImage:Class;
		
		// the injury image
		[Embed(source = "../../../../../assets/injury.png")]
		public var injuryImage:Class;
		
		// the injury icon image
		[Embed(source = "../../../../../assets/injury_image.png")]
		public var injuryIconImage:Class;
		
		// the first image
		[Embed(source = "../../../../../assets/first.png")]
		public var firstImage:Class;
		
		// the second image
		[Embed(source = "../../../../../assets/second.png")]
		public var secondImage:Class;
		
		// the third image
		[Embed(source = "../../../../../assets/third.png")]
		public var thirdImage:Class;
		
	}

}