package com.divillysausages.sprint.gui 
{
	import com.divillysausages.ds.core.Layer;
	
	/**
	 * The main game gui
	 * @author Damian
	 */
	public class GUI
	{
		
		/*******************************************************************************************/
		
		/**
		 * The name for the tracks layer
		 */
		public static const LAYER_TRACKS:String = "tracks";
		
		/*******************************************************************************************/
		
		private var m_main:Main		= null;	// the Main class
		private var m_tracks:Layer 	= null; // the layer for the tracks
		
		/*******************************************************************************************/
		
		/**
		 * [read-only] The Layer for the tracks in the game
		 */
		public function get trackLayer():Layer { return this.m_tracks; }
		
		/*******************************************************************************************/
		
		/**
		 * Creates our GUI class
		 * @param m	A reference to the Main class
		 */
		public function GUI( m:Main ) 
		{
			this.m_main = m;
		}
		
		/*******************************************************************************************/
		
		/**
		 * Inits our GUI class, creating all the different objects
		 */
		public function init():void
		{
			// create our layers
			this.m_tracks = new Layer( GUI.LAYER_TRACKS );
			
			// our layers are invisible for the minute
			this.m_tracks.visible 	= false;
			this.m_tracks.active	= false;
		}
		
	}

}