package com.divillysausages.sprint.gui 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.constants.Style;
	import flash.filters.DropShadowFilter;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class GameInstructions extends TextField implements IUpdateObj
	{
		
		/*******************************************************************************************/
		
		private var m_isActive:Boolean		= false;// are we active?
		private var m_currRadians:Number	= 0.0;	// our current angle (for blink)
		
		/*******************************************************************************************/
		
		public function get active():Boolean { return this.m_isActive; }
		
		/*******************************************************************************************/
		
		/**
		 * Creates a new GameInstructions class
		 */
		public function GameInstructions()
		{
			this.defaultTextFormat	= new TextFormat( Resources.GAME_FONT, Style.GAME_INSTRUCTIONS_SIZE, Style.GAME_INSTRUCTIONS_COLOUR );
			this.autoSize			= TextFieldAutoSize.LEFT;
			this.mouseEnabled		= false;
			this.mouseWheelEnabled	= false;
			this.selectable			= false;
			this.multiline			= false;
			this.embedFonts			= true;
			this.text				= " ";
			this.filters			= [new DropShadowFilter( 0, 0, 0, 1, 4, 4, 40 )];
			
			// add us to the update
			DS.addToUpdate( this );
		}
		
		/**
		 * Destroys the GameInstructions and clears it for garbage collection
		 */
		public function destroy():void
		{
			// remove us from the update
			DS.removeFromUpdate( this );
			
			// remove graphics
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
		/**
		 * Resets the GameInstructions so it can be reused
		 */
		public function reset():void
		{
			this.m_isActive	= false;
			this.visible	= false;
		}
		
		/**
		 * Shows the GameInstructions
		 */
		public function show( text:String ):void
		{
			this.text			= text;
			this.x				= DS.stage.stageWidth * 0.5 - this.width * 0.5;
			this.m_currRadians	= 0.0;
			this.alpha			= 1.0;
			this.visible		= true;
			this.m_isActive		= true;
		}
		
		/**
		 * Called every frame we're active
		 * @param dt The current dt
		 */
		public function update( dt:Number ):void
		{
			// update our time
			this.m_currRadians += dt * 4.0;
			if ( this.m_currRadians > Math.PI * 2.0 )
				this.m_currRadians -= Math.PI * 2.0;
				
			// update our alpha
			this.alpha = 0.5 + ( Math.sin( this.m_currRadians ) + 1.0 ) / 4.0;
		}
		
	}

}