package com.divillysausages.sprint.gui
{	
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.util.Colour;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.constants.Constants;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	public class Injury extends Sprite implements IUpdateObj
	{
		
		/*******************************************************************************************/
		
		private var m_isActive:Boolean		= false;// are we active?
		private var m_currRadians:Number	= 0.0;	// our current angle (for blink)
		private var m_icon:Bitmap			= null; // our bitmap icon
		private var m_txt:Bitmap			= null;	// our bitmap image
		
		/*******************************************************************************************/
		
		public function get active():Boolean { return this.m_isActive; }
		
		/*******************************************************************************************/
		
		/**
		 * Creates a new Injury class
		 */
		public function Injury()
		{
			// add our icon
			this.m_icon		= DS.getAsset( Resources.INJURY_ICON_IMAGE ).bitmap;
			this.m_icon.x	= 0.0;
			this.m_icon.y	= -this.m_icon.height * 0.5;
			this.addChild( this.m_icon );
			
			// add our text
			this.m_txt 		= DS.getAsset( Resources.INJURY_IMAGE ).bitmap;
			this.m_txt.x	= 40.0;
			this.m_txt.y	= -this.m_txt.height * 0.5;
			this.addChild( this.m_txt );
			
			// stop interaction
			this.mouseChildren	= false;
			this.mouseEnabled	= false;
			
			// add us to the update
			DS.addToUpdate( this );
		}
		
		/**
		 * Destroys the Injury and clears it for garbage collection
		 */
		public function destroy():void
		{
			// remove us from the update
			DS.removeFromUpdate( this );
			
			// remove graphics
			this.removeChild( this.m_txt );
			if ( this.parent != null )
				this.parent.removeChild( this );
				
			// null our properties
			this.m_txt = null;
		}
		
		/**
		 * Resets the injury so it can be reused
		 */
		public function reset():void
		{
			this.m_isActive	= false;
			this.visible	= false;
		}
		
		/**
		 * Shows the injury
		 */
		public function show():void
		{
			this.m_currRadians	= 0.0;
			this.alpha			= 1.0;
			this.visible		= true;
			this.m_isActive		= true;
		}
		
		/**
		 * Called every frame we're active
		 * @param dt The current dt
		 */
		public function update( dt:Number ):void
		{
			// update our time
			this.m_currRadians += dt * 4.0;
			if ( this.m_currRadians > Math.PI * 2.0 )
				this.m_currRadians -= Math.PI * 2.0;
				
			// update our alpha
			this.alpha = 0.5 + ( Math.sin( this.m_currRadians ) + 1.0 ) / 4.0;
		}
		
	}

}