package com.divillysausages.sprint.gui
{	
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.sprint.assets.Resources;
	import flash.display.Bitmap;
	
	public class PersonalBest extends Bitmap implements IUpdateObj
	{
		
		/*******************************************************************************************/
		
		private var m_isActive:Boolean		= false;// are we active?
		private var m_currRadians:Number	= 0.0;	// our current angle (for blink)
		
		/*******************************************************************************************/
		
		public function get active():Boolean { return this.m_isActive; }
		
		/*******************************************************************************************/
		
		/**
		 * Creates a new PersonalBest class
		 */
		public function PersonalBest()
		{
			this.bitmapData = DS.getAsset( Resources.NEW_PB_IMAGE ).bitmapData;
			
			// add us to the update
			DS.addToUpdate( this );
		}
		
		/**
		 * Destroys the PersonalBest and clears it for garbage collection
		 */
		public function destroy():void
		{
			// remove us from the update
			DS.removeFromUpdate( this );
			
			// remove graphics
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
		/**
		 * Resets the PersonalBest so it can be reused
		 */
		public function reset():void
		{
			this.m_isActive	= false;
			this.visible	= false;
		}
		
		/**
		 * Shows the PersonalBest
		 */
		public function show():void
		{
			this.m_currRadians	= 0.0;
			this.alpha			= 1.0;
			this.visible		= true;
			this.m_isActive		= true;
		}
		
		/**
		 * Called every frame we're active
		 * @param dt The current dt
		 */
		public function update( dt:Number ):void
		{
			// update our time
			this.m_currRadians += dt * 4.0;
			if ( this.m_currRadians > Math.PI * 2.0 )
				this.m_currRadians -= Math.PI * 2.0;
				
			// update our alpha
			this.alpha = 0.5 + ( Math.sin( this.m_currRadians ) + 1.0 ) / 4.0;
		}
		
	}

}