package com.divillysausages.sprint.gui 
{
	import com.divillysausages.ds.DS;
	import com.divillysausages.sprint.constants.Constants;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Shape;
	import flash.geom.Rectangle;
	
	/**
	 * The texture that we put over everything to give it a pixel look
	 * @author Damian Connolly
	 */
	public class PixelTexture extends Shape
	{
		
		/**
		 * Creates a new PixelTexture that covers the stage
		 */
		public function PixelTexture() 
		{
			// create our texture
			var bmd:BitmapData = new BitmapData( Constants.PIXEL_SIZE, Constants.PIXEL_SIZE, true, 0x00000000 );
			bmd.fillRect( new Rectangle( 0, 0, Constants.PIXEL_SIZE, 1 ), 0xffffffff );
			bmd.fillRect( new Rectangle( 0, 0, 1, Constants.PIXEL_SIZE ), 0xffffffff );
			bmd.fillRect( new Rectangle( 0, Constants.PIXEL_SIZE - 1, Constants.PIXEL_SIZE, 1 ), 0xff000000 );
			bmd.fillRect( new Rectangle( Constants.PIXEL_SIZE - 1, 1, 1, Constants.PIXEL_SIZE - 1 ), 0xff000000 );
			
			// draw our texture
			this.graphics.beginBitmapFill( bmd );
			this.graphics.drawRect( 0.0, 0.0, DS.stage.stageWidth, DS.stage.stageHeight );
			this.graphics.endFill();
			
			// blend and add us
			this.blendMode 	= BlendMode.OVERLAY;
			this.alpha		= 0.2;
			DS.stage.addChild( this );
		}
		
	}

}