package com.divillysausages.sprint.states 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.constants.Style;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	/**
	 * Checks to see if all our images are ok
	 * TODO: Remove ImageSummer from the game when finished
	 * @author Damian
	 */
	public class StateCheck extends GameState
	{
		
		/*******************************************************************************************/
		
		private var m_text:TextField			= null; // our textfield
		private var m_main:Main					= null;	// our main image
		//private var m_summer:ImageSummer 		= null; // our image summer object
		//private var m_verifier:ImageVerifier	= null;	// our image verifier
		private var m_checking:Boolean			= false;// are we checking yet?
		private var m_wait:int					= 0;	// how long to wait
		
		/*******************************************************************************************/
		
		/**
		 * Creates our state check
		 */
		public function StateCheck( m:Main, name:String ) 
		{
			this.m_main = m;
			super( name );
			
			// create our text
			this._createText();
		}
		
		/**
		 * Start the state
		 */
		override public function begin():void
		{			
			// add our text
			DS.canvas.addChild( this.m_text );
			
			// our summer
			//this.m_summer = new ImageSummer;
			//DS.stage.addChild( this.m_summer );
			
			// our verifier
			//this.m_verifier = new ImageVerifier;
			
			this.m_checking = false;
			this.m_wait		= 0;
		}
		
		/**
		 * End the state
		 */
		override public function end():void
		{
			// remove our text
			DS.canvas.removeChild( this.m_text );
			
			// our summer
			//this.m_summer.destroy();
			//DS.stage.removeChild( this.m_summer );
			//this.m_summer = null;
			
			// our verifier
			//this.m_verifier.destroy();
			//this.m_verifier = null;
		}
		
		/**
		 * Updates the StateCheck state
		 * @param dt	The delta time
		 */
		override public function update(dt:Number):void 
		{
			if ( this.m_wait < 3 )
			{
				this.m_wait++;
				return;
			}
			
			if ( !this.m_checking )
			{
				//this.m_summer.start();
				//this.m_verifier.start();
				this.m_checking = true;
				
				// TODO: Add image verifier and image summer classes
				if ( true )
					Game.changeState( Game.STATE_DS );
				else
					Game.changeState( Game.STATE_HACKED );
			}
		}
		
		/*******************************************************************************************/
		
		// create the textfield that we'll use
		private function _createText():void
		{
			var tf:TextFormat 				= new TextFormat( Resources.GAME_FONT, Style.LOADING_SIZE, Style.LOADING_COLOUR );
			this.m_text 					= new TextField;
			this.m_text.defaultTextFormat 	= tf;
			this.m_text.autoSize			= TextFieldAutoSize.LEFT;
			this.m_text.text				= "LOADING...";
			this.m_text.selectable			= false;
			this.m_text.mouseEnabled		= false;
			this.m_text.mouseWheelEnabled	= false;
			this.m_text.embedFonts			= true;
			this.m_text.x					= int( DS.stage.stageWidth * 0.5 - this.m_text.width * 0.5 );
			this.m_text.y					= int( DS.stage.stageHeight * 0.5 - this.m_text.height * 0.5 );
		}
		
	}

}