package com.divillysausages.sprint.states 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.external.ExternalAPI;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.constants.Style;
	import flash.external.ExternalInterface;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	/**
	 * The state we go to if we detect that the game's been hacked
	 * @author Damian
	 */
	public class StateHacked extends GameState
	{
		
		/*******************************************************************************************/
		
		private var m_main:Main			= null;
		private var m_text:TextField 	=  null;
		
		/*******************************************************************************************/
		
		/**
		 * Create our pause screen
		 */
		public function StateHacked( m:Main, name:String ) 
		{
			this.m_main = m;
			super( name );
			
			// create our text
			this._createText();
		}
		
		/**
		 * Show the hacked screen
		 */
		override public function begin():void
		{			
			// add us
			DS.canvas.addChild( this.m_text );
			if ( ExternalInterface.available )
				ExternalAPI.trackEvent( "[Hacked screen] " + ExternalInterface.call( "window.location.href" ) );
			else
				ExternalAPI.trackEvent( "[Hacked screen] " + DS.stage.loaderInfo.loaderURL );
		}
		
		/**
		 * We can't hide the hacked screen
		 */
		override public function end():void
		{
			// don't hide
			Game.changeState( Game.STATE_HACKED );
		}
		
		/*******************************************************************************************/
		
		// create the textfield
		private function _createText():void
		{
			var tf:TextFormat 	= new TextFormat( Resources.GAME_FONT, Style.HACKED_SIZE, Style.HACKED_COLOUR );
			tf.align			= TextFormatAlign.CENTER;
			
			// set the message
			var msg:String = "<font size='" + Style.HACKED_TITLE_SIZE + "'>SORRY</font>\nIT LOOKS LIKE THIS GAME HAS BEEN HACKED\n\n" + 
							"PLEASE SUPPORT THE ORIGINAL DEVS. YOU CAN FIND MORE INFO ON THE ORIGINAL GAME AT" + 
							"\n<a href=\"http://divillysausages.com/10SecondSprint\">HTTP://DIVILLYSAUSAGES.COM/10SECONDSPRINT</a>" +
							"\n\nTHANK YOU";
								
			// our stylesheet for the link
			var style:StyleSheet 	= new StyleSheet();
			var link:Object 		= new Object;
			link.color 				= Style.HACKED_LINK_COLOUR;
			style.setStyle( "a", link );
			
			// our textfield
			this.m_text 					= new TextField;
			this.m_text.defaultTextFormat	= tf;
			this.m_text.styleSheet			= style;
			this.m_text.htmlText			= msg;
			this.m_text.selectable			= false;
			this.m_text.embedFonts			= true;
			this.m_text.multiline			= true;
			this.m_text.width				= 600.0;
			this.m_text.wordWrap			= true;
			this.m_text.height				= this.m_text.textHeight + 4.0;
			this.m_text.x 					= int( DS.stage.stageWidth * 0.5 - this.m_text.width * 0.5 );
			this.m_text.y					= int( DS.stage.stageHeight * 0.5 - this.m_text.height * 0.5 );
		}
		
	}

}