package com.divillysausages.sprint.states 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.ds.input.Input;
	import com.divillysausages.ds.input.Key;
	import com.divillysausages.sprint.anim.AnimParser;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.gui.GUI;
	import com.divillysausages.sprint.gui.PixelTexture;
	import com.divillysausages.sprint.logic.GameSave;
	import com.divillysausages.sprint.logic.Logic;
	import flash.display.BlendMode;
	import flash.display.Shape;
	
	/**
	 * The init state that creates everything
	 * @author Damian
	 */
	public class StateInit extends GameState
	{
		
		/*******************************************************************************************/
		
		private var m_main:Main 		= null;		// a reference to the main class
		private var m_inited:Boolean	= false;	// have we inited the game
		
		/*******************************************************************************************/
		
		/**
		 * Creates the init state
		 * @param m		The init state
		 * @param name	The name of the state
		 */
		public function StateInit( m:Main, name:String ) 
		{
			this.m_main = m;
			super(name);
			
			// create the resources that we'll use in the game
			new Resources;
		}
		
		/**
		 * Inits our game
		 */
		override public function begin():void 
		{
			if ( this.m_inited )
			{
				DS.error( this, "We've already inited the game" );
				Game.changeState( Game.STATE_MAIN_MENU );
				return;
			}
			
			// create a new texture shape for the bg
			//var s:Shape = new Shape;
			//s.graphics.beginBitmapFill( Texture.texture );
			//s.graphics.drawRect( 0.0, 0.0, DS.stage.stageWidth, DS.stage.stageHeight );
			//s.blendMode = BlendMode.MULTIPLY;
			//s.alpha		= 0.2;
			//DS.canvas.addChild( s );
			
			// create our gui
			this.m_main.gui = new GUI( this.m_main );
			this.m_main.gui.init();
			
			// create our logic
			this.m_main.logic = new Logic();
			
			// init our anim parser
			AnimParser.instance.init();
			
			// create our texture
			new PixelTexture();
			
			// we've initied
			this.m_inited = true;
			
			Input.bind( Key.DELETE, function():void
			{
				GameSave.instance.reset();
			});
			
			// go to our check state
			//Game.changeState( Game.STATE_CHECK );
			Game.changeState( Game.STATE_DS );
		}
		
	}

}