package com.divillysausages.sprint.states 
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.sprint.assets.Resources;
	import com.divillysausages.sprint.constants.Style;
	import com.divillysausages.sprint.gui.GameButton;
	import flash.filters.DropShadowFilter;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	/**
	 * The init state that creates everything
	 * @author Damian
	 */
	public class StateMainMenu extends GameState
	{
		
		/*******************************************************************************************/
		
		private var m_title:TextField	= null; // the title
		private var m_main:Main 		= null;	// a reference to the main class
		private var m_play:GameButton	= null;	// the play button
		
		/*******************************************************************************************/
		
		/**
		 * Creates the init state
		 * @param m		The init state
		 * @param name	The name of the state
		 */
		public function StateMainMenu( m:Main, name:String ) 
		{
			this.m_main = m;
			super(name);
			
			// create our play button
			this.m_play 	= new GameButton( "Play game", this._onPlay );
			this.m_play.x	= DS.stage.stageWidth * 0.5 - this.m_play.width * 0.5;
			this.m_play.y	= DS.stage.stageHeight * 0.5 - this.m_play.height * 0.5;
			
			// create our title
			this.m_title 					= new TextField;
			this.m_title.defaultTextFormat	= new TextFormat( Resources.GAME_FONT, Style.COUNTDOWN_SIZE, Style.INSTRUCTIONS_COLOUR );
			this.m_title.autoSize			= TextFieldAutoSize.LEFT;
			this.m_title.selectable			= false;
			this.m_title.mouseEnabled		= false;
			this.m_title.mouseWheelEnabled	= false;
			this.m_title.multiline			= false;
			this.m_title.embedFonts			= true;
			this.m_title.text				= "10 Second Sprint";
			this.m_title.filters			= [new DropShadowFilter( 0, 0, 0, 1, 4, 4, 40 )];
			this.m_title.x					= DS.stage.stageWidth * 0.5 - this.m_title.width * 0.5;
			this.m_title.y					= 50.0;
		}
		
		/**
		 * Starts the main menu state
		 */
		override public function begin():void 
		{
			// set the bg colour
			DS.bgColour = Main.BG_COLOUR;
			
			// show our play button
			this.m_play.active = true;
			DS.canvas.addChild( this.m_play );
			
			DS.canvas.addChild( this.m_title );
		}
		
		/**
		 * Ends the main menu state
		 */
		override public function end():void 
		{
			this.m_play.active = false;
			DS.canvas.removeChild( this.m_play );
			DS.canvas.removeChild( this.m_title );
		}
		
		/*******************************************************************************************/
		
		// called when we click on the play game button
		private function _onPlay():void
		{
			//Game.changeState( Game.STATE_OVERVIEW );
			Game.changeState( Game.STATE_PLAY );
		}
		
	}

}